%% "The spectral analysis of the Hodrick-Prescott filter," Neslihan Sakarya and Robert M. de Jong (2021)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% This file allows you to plot Figure 1 of the paper. 'flambda.m,' 'autocov_wn.m,' 'autocov_tau_wn,' and 'autocov_c_wn' files need to be 
%in the same folder with this file while compiling the results.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



clear all;
close all;
clc;

T=1000; %large sample size
lmb=6.25;
kmax=25;
k=0:kmax;
sigmasq=1;

wn_autocov=[k',autocov_wn(sigmasq,k)'];

wn_tau_autocov=zeros(kmax+1,1);
wn_c_autocov=zeros(kmax+1,1);

for j=1:kmax+1;
    
wn_tau_autocov(j)=autocov_tau_wn(j-1,sigmasq,lmb,T);
wn_c_autocov(j)=autocov_c_wn(j-1,sigmasq,lmb,T);
end



wn_tau_autocov=[k',wn_tau_autocov];

wn_c_autocov=[k',wn_c_autocov];

plot(k',wn_tau_autocov(:,2),'o')
hold all
plot(k',wn_c_autocov(:,2),'o')
hold all
plot(k',wn_autocov(:,2),'o')



