%% "The spectral analysis of the Hodrick-Prescott filter," Neslihan Sakarya and Robert M. de Jong (2020)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% This file allows you to plot Figure 2 of the paper. 'hlambda.m' file needs to be in the same folder with this file while compiling the results.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all;
close all;
clc;

lmb=[6.25, 1600, 129600]; %The smoothing parameter values.

omg=[0:0.05:pi]'; %The frequency values: omega \in [0,pi].



result=zeros(length(omg), length(lmb));

for j=1:length(lmb);
for    i=1:length(omg);
    
   result(i,j)=(1-hlambda(omg(i),lmb(j)))^2; % This loop calculates (1-h_{\lambda}(omega)) for \lambda=6.25, 1600, and 129600 and \omega \in [0, pi].
end
end

%% Run the file to compile Figure 1.

plot(omg,result(:,1))
 hold all
plot(omg,result(:,2))
hold all
 plot(omg,result(:,3))